Index: src/Actions/SelectionAction/NotMoleculeByIdAction.cpp
===================================================================
--- src/Actions/SelectionAction/NotMoleculeByIdAction.cpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/NotMoleculeByIdAction.cpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -20,6 +20,4 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/NotMoleculeByIdAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "molecule.hpp"
 #include "Helpers/Log.hpp"
@@ -32,53 +30,18 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/NotMoleculeByIdAction.hpp"
 
+// and construct the stuff
+#include "NotMoleculeByIdAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr SelectionNotMoleculeByIdAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
 
-// memento to remember the state when undoing
-
-class SelectionNotMoleculeByIdState : public ActionState {
-public:
-  SelectionNotMoleculeByIdState(molecule* _mol) :
-    mol(_mol)
-  {}
-  molecule* mol;
-};
-
-const char SelectionNotMoleculeByIdAction::NAME[] = "unselect-molecule-by-id";
-
-SelectionNotMoleculeByIdAction::SelectionNotMoleculeByIdAction() :
-  Action(NAME)
-{}
-
-SelectionNotMoleculeByIdAction::~SelectionNotMoleculeByIdAction()
-{}
-
-void SelectionNotMoleculeById(molecule *_mol) {
-  ValueStorage::getInstance().setCurrentValue(SelectionNotMoleculeByIdAction::NAME, _mol);
-  ActionRegistry::getInstance().getActionByName(SelectionNotMoleculeByIdAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionNotMoleculeByIdAction::getParametersfromValueStorage()
-{};
-
-Dialog* SelectionNotMoleculeByIdAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryMolecule(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
-Action::state_ptr SelectionNotMoleculeByIdAction::performCall() {
-  molecule *mol = NULL;
-
-  ValueStorage::getInstance().queryCurrentValue(NAME, mol);
-
-  if (World::getInstance().isSelected(mol)) {
-    DoLog(1) && (Log() << Verbose(1) << "Unselecting molecule " << mol->name << endl);
-    World::getInstance().unselectMolecule(mol);
-    return Action::state_ptr(new SelectionNotMoleculeByIdState(mol));
+  if (World::getInstance().isSelected(params.mol)) {
+    DoLog(1) && (Log() << Verbose(1) << "Unselecting molecule " << params.mol->name << endl);
+    World::getInstance().unselectMolecule(params.mol);
+    return Action::state_ptr(new SelectionNotMoleculeByIdState(params));
   } else {
     return Action::success;
@@ -89,8 +52,8 @@
   SelectionNotMoleculeByIdState *state = assert_cast<SelectionNotMoleculeByIdState*>(_state.get());
 
-  if (state->mol != NULL)
-    World::getInstance().selectMolecule(state->mol);
+  if (state->params.mol != NULL)
+    World::getInstance().selectMolecule(state->params.mol);
 
-  return Action::state_ptr(new SelectionNotMoleculeByIdState(state->mol));
+  return Action::state_ptr(_state);
 }
 
@@ -98,8 +61,8 @@
   SelectionNotMoleculeByIdState *state = assert_cast<SelectionNotMoleculeByIdState*>(_state.get());
 
-  if (state->mol != NULL)
-    World::getInstance().unselectMolecule(state->mol);
+  if (state->params.mol != NULL)
+    World::getInstance().unselectMolecule(state->params.mol);
 
-  return Action::state_ptr(new SelectionNotMoleculeByIdState(state->mol));
+  return Action::state_ptr(_state);
 }
 
@@ -115,2 +78,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/NotMoleculeByIdAction.def
===================================================================
--- src/Actions/SelectionAction/NotMoleculeByIdAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
+++ src/Actions/SelectionAction/NotMoleculeByIdAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -0,0 +1,25 @@
+/*
+ * NotMoleculeByIdAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class molecule;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (molecule*)
+#define paramtokens (SelectionNotMoleculeByIdAction::NAME)
+#define paramreferences (mol)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME NotMoleculeById
+#define TOKEN "unselect-molecule-by-id"
+
Index: src/Actions/SelectionAction/NotMoleculeByIdAction.hpp
===================================================================
--- src/Actions/SelectionAction/NotMoleculeByIdAction.hpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/NotMoleculeByIdAction.hpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -11,29 +11,6 @@
 #include "Actions/Action.hpp"
 
-class molecule;
-
-void SelectionNotMoleculeById(molecule *_mol);
-
-class SelectionNotMoleculeByIdAction : public Action {
-  friend void SelectionNotMoleculeById(molecule *_mol);
-
-public:
-  SelectionNotMoleculeByIdAction();
-  virtual ~SelectionNotMoleculeByIdAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "NotMoleculeByIdAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* NOTMOLECULEBYIDACTION_HPP_ */
Index: src/Actions/SelectionAction/NotMoleculeOfAtomAction.cpp
===================================================================
--- src/Actions/SelectionAction/NotMoleculeOfAtomAction.cpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/NotMoleculeOfAtomAction.cpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -20,6 +20,4 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/NotMoleculeOfAtomAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/MoleculeDescriptor.hpp"
 #include "atom.hpp"
@@ -33,54 +31,18 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/NotMoleculeOfAtomAction.hpp"
 
-
-// memento to remember the state when undoing
-
-class SelectionNotMoleculeOfAtomState : public ActionState {
-public:
-  SelectionNotMoleculeOfAtomState(std::vector<molecule*> selectedMolecules, atom *_Walker) :
-    selectedMolecules(selectedMolecules),
-    Walker(_Walker)
-  {}
-  std::vector<molecule*> selectedMolecules;
-  atom *Walker;
-};
-
-const char SelectionNotMoleculeOfAtomAction::NAME[] = "unselect-molecule-of-atom";
-
-SelectionNotMoleculeOfAtomAction::SelectionNotMoleculeOfAtomAction() :
-  Action(NAME)
-{}
-
-SelectionNotMoleculeOfAtomAction::~SelectionNotMoleculeOfAtomAction()
-{}
-
-void SelectionNotMoleculeOfAtom() {
-  ActionRegistry::getInstance().getActionByName(SelectionNotMoleculeOfAtomAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionNotMoleculeOfAtomAction::getParametersfromValueStorage()
-{};
-
-Dialog* SelectionNotMoleculeOfAtomAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryAtom(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "NotMoleculeOfAtomAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr SelectionNotMoleculeOfAtomAction::performCall() {
-  atom *Walker = NULL;
-
-  ValueStorage::getInstance().queryCurrentValue(NAME, Walker);
+  // obtain information
+  getParametersfromValueStorage();
 
   std::vector<molecule *> selectedMolecules = World::getInstance().getSelectedMolecules();
-  DoLog(1) && (Log() << Verbose(1) << "Unselecting molecule to which " << Walker->getName() << " belongs." << endl);
-  World::getInstance().unselectMoleculeOfAtom(Walker);
-  return Action::state_ptr(new SelectionNotMoleculeOfAtomState(selectedMolecules, Walker));
+  DoLog(1) && (Log() << Verbose(1) << "Unselecting molecule to which " << params.Walker->getName() << " belongs." << endl);
+  World::getInstance().unselectMoleculeOfAtom(params.Walker);
+  return Action::state_ptr(new SelectionNotMoleculeOfAtomState(selectedMolecules, params));
 }
 
@@ -92,5 +54,5 @@
     World::getInstance().selectMolecule(*iter);
 
-  return Action::state_ptr(new SelectionNotMoleculeOfAtomState(state->selectedMolecules, state->Walker));
+  return Action::state_ptr(_state);
 }
 
@@ -98,7 +60,7 @@
   SelectionNotMoleculeOfAtomState *state = assert_cast<SelectionNotMoleculeOfAtomState*>(_state.get());
 
-  World::getInstance().unselectMoleculeOfAtom(state->Walker);
+  World::getInstance().unselectMoleculeOfAtom(state->params.Walker);
 
-  return Action::state_ptr(new SelectionNotMoleculeOfAtomState(state->selectedMolecules, state->Walker));
+  return Action::state_ptr(_state);
 }
 
@@ -114,2 +76,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/NotMoleculeOfAtomAction.def
===================================================================
--- src/Actions/SelectionAction/NotMoleculeOfAtomAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
+++ src/Actions/SelectionAction/NotMoleculeOfAtomAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -0,0 +1,24 @@
+/*
+ * NotMoleculeOfAtomAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (atom*)
+#define paramtokens (SelectionNotMoleculeOfAtomAction::NAME)
+#define paramreferences (Walker)
+
+#define statetypes (std::vector<molecule*>)
+#define statereferences (selectedMolecules)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME NotMoleculeOfAtom
+#define TOKEN "unselect-molecule-of-atom"
+
Index: src/Actions/SelectionAction/NotMoleculeOfAtomAction.hpp
===================================================================
--- src/Actions/SelectionAction/NotMoleculeOfAtomAction.hpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/NotMoleculeOfAtomAction.hpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -11,27 +11,6 @@
 #include "Actions/Action.hpp"
 
-void SelectionNotMoleculeOfAtom();
-
-class SelectionNotMoleculeOfAtomAction : public Action {
-  friend void SelectionNotMoleculeOfAtom();
-
-public:
-  SelectionNotMoleculeOfAtomAction();
-  virtual ~SelectionNotMoleculeOfAtomAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "NotMoleculeOfAtomAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* NOTMOLECULEOFATOMSACTION_HPP_ */
